<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title>Anchor</title>
<meta name="Generator" content="SciTE - www.Scintilla.org" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<link rel="StyleSheet" HREF="anchor.css" TYPE="text/css" />
</head>
<body bgcolor="#FFFFFF"><div id="main"><h2>

<a href="http://anch.org">anch.org</a>: Anchor</h2><p>

<a>A</a>nother <a>N</a>ifty <a>C</a>oding <a>H</a>elper.</p><p>

Version: 1.5</p>

<img src="images/anchorcode.gif" alt="Anchor: for  i=5;i--;  C: for (i=5;i--;){"/><h3>

Why Anchor?</h3><p>

Anchor saves typing and makes programs easier to read. Best of all, it's free!</p><p>

Techies might refer to it as a language-independent pseudocode compiler or code decorator.</p><h3>

Installation</h3><p>

A windows .exe is provided already. Just copy it somewhere in your computer&apos;s path. If you want to compile it yourself, make sure you have installed <a href="http://flex.sourceforge.net/">flex</a> and a C compiler. <a href="http://anch.org/anchor.zip">Download</a> and extract the archive.</p>
<pre>
unzip anchor.zip
cd anchor
</pre><p>
Run &quot;make&quot; from within the newly extracted directory.</p>
<pre>
make
su -c &apos;make install&apos;</pre><h3>

Programming with Anchor</h3><p>

The rules are very simple. A double-space, &quot;&nbsp; &quot; (tells anchor to enclose the rest of the line in parenthesis). Indentation of 4 spaces {controls the placement of curly brackets}. The remaining lines are automatically terminated with semicolons; any of these rules can be overridden by placing whitespace or a <span class="S1">/* comment */</span> or <span class="S1">//</span> at the end of the line, causing the precompiler to skip the line in question.</p><h3>
Compilation</h3><p>

Use anchor.exe to convert example.a.c to C:</p>
<pre>
anchor example.a.c > example.c</pre><p>

Anchor was designed for C, but it should process most other curly bracket languages, like C++, Java, PHP, Perl and .NET as well. On Linux or Unix-based systems, programs are compiled by putting &quot;anch&quot; in front of the compiler you already use. Windows users would need to install something like <a href="http://sourceforge.net/projects/mingw/files/">MingW</a> or <a href="http://www.cygwin.com/">cygwin</a> to make the rest of these examples work.</p>
<pre>
make example
anch gcc example.a.c -o example</pre><p>

Experimental &quot;un-anchoring&quot; of code is provided. (requires <a href="http://www.gnu.org/software/indent/">GNU indent</a>)</p>
<pre>
unanchor example.c #see how it would look
unanchor example.c > editme.a.c # create a file</pre><p>

<a href="windows.a.html">see an unanchored C windows program</a></p><h3><a href="http://bellard.org/tcc/">

Optional TCC integration</a></h3><p>

With <a href="http://bellard.org/tcc/">TCC</a> installed, you can run Anchor programs directly from the command line.</p>
<pre>
anch -run example.a.c
</pre><p>
Or put the following line</p>

<pre><span class="S9">#!/usr/local/bin/anch -run [args]</span></pre><p>

at the top of files to make executable C scripts:</p>
<pre><span class="S9">#!/usr/local/bin/anch -run</span>
<span class="S9">#include &lt;stdio.h&gt;</span>
<span class="S5">int</span><span class="S0"> </span>main<span class="S0">  </span><span class="S5">int</span><span class="S0"> </span>c<span class="S10">,</span><span class="S0"> </span><span class="S5">char</span><span class="S0"> </span><span class="S10">**</span>v
<span class="S0">    </span><span class="S5">while</span><span class="S0">  </span>c<span class="S10">--</span>
<span class="S0">        </span><span class="S16">printf</span><span class="S0">  </span><span class="S6">"Argument %i is \"%s\"\n"</span><span class="S10">,</span>c<span class="S10">,</span>v<span class="S10">[</span>c<span class="S10">]</span>
<span class="S0">    </span><span class="S5">return</span><span class="S0"> </span><span class="S4">0</span>
<span class="S0"></span></pre><h3>
Direct execution</h3><p>

Anchor can use <a href="http://bellard.org/tcc/">TCC</a> to execute through a pipe. For example, if you have both <a href="http://www.vergenet.net/~conrad/software/xsel/">xsel</a> and <a href="http://bellard.org/tcc/">TCC</a> installed, you could highlight the above code with the mouse and run it immediately from the selection buffer (without even saving to disk).</p>
<pre>
xsel | anch -run - [args]</pre><p>

I made a pre-release Linux (RPM) version of TCC <a href="http://thenerdshow.com/rpm/tinycc-git20100114-2.fc13.src.rpm">here</a></p>
<h3>

Changelog</h3><p>


Wed Nov 10 2010 1.5 -run now accepts linker options like -lm.</p><p>

Mon Oct 25 2010 1.4 Now works as a code decorator.</p><p>

Tue Apr 27 2010 1.3 String arrays can be defined like this:</p>
<pre>
<span class="S0">    </span><span class="S5">char</span><span class="S0"> </span>a<span class="S10">[</span><span class="S4">6</span><span class="S10">][</span><span class="S4">10</span><span class="S10">]=</span><span class="S0"> </span><span class="S6">"rain gear"</span><span class="S10">,</span><span class="S0"> </span><span class="S6">"boots"</span><span class="S10">,</span><span class="S0"> </span><span class="S6">"nets"</span><span class="S10">,</span>
<span class="S0">        </span><span class="S6">"skiff"</span><span class="S10">,</span><span class="S0"> </span><span class="S6">"outboard"</span><span class="S10">,</span><span class="S0"> </span><span class="S4">0</span></pre>

Thu Apr 15 2010 1.2 <a href="http://bellard.org/tcc/">TCC</a> Integration.</p><p>

Wed Apr 14 2010 1.1 Buffered comments. Quoted strings. Support for structs &amp; arrays. Lots of bug fixes.</p><p>

Mon Apr 12 2010 1.0 Completely re-written using <a href="http://flex.sourceforge.net/">flex</a>, a lexical analyzer and parser generator.</p><h3><a name="legal">

Limitations and Copyright</a></h3><p>

No warrantee! Anchor was created as a learning toy for hobbies and fun; it might lack the swagger of commercial projects. The algorithm is potentially lossy and subject to change, so don't distribute important software that depends on it (convert it to C first). C is a difficult language to learn and Anchor is not guaranteed to make it easier. Our &quot;precompiler&quot;, anch is just a simple bash script that creates a temp file and invokes whatever compiler you normally use. You are free to adapt it to your needs under the terms of the <a href="http://www.gnu.org/licenses/gpl.html">Gnu Public License</a>.</p>

<p class="small">

Anchor and accompanying documentation is Copyright &copy; 2010 Henry Kroll III. You are free to share, adapt and re-distribute this page under the terms of the Creative Commons SA license inasmuch as it agrees with the terms of the GPL. Any of the above conditions can be waived if you get permission from the copyright holder.</p>



</div>


<!-- begin LEFT BAR -->

<div id="list1" ><a href="http://anch.org">
    <img id="anchor" style="padding-left:20px;border:0px;" src="images/anchor.jpg" alt=

    " Anchor " onmouseover="moveObjRight();" onmouseout="moveObjLeft();" /></a>



    <div class="b" style="top:9em;"> <a href="mailto:nospam&#64;thenerdshow.com?subject=Anchor" title="Feedback">
CONTACT</a></div>
     
     <div class="b" style="top:11em;"> <a href="http://anch.org/" title="Main Page">
AUTHOR</a></div>

    <div class="b" style="top:13em;"> <a href="http://anch.org/anchor.zip" title="Get Anchor">
DOWNLOAD</a></div>

    <div class="b" style="top:13em;"> <a href="#legal" title="License">
LISCENSE</a></div>

    <div class="b" style="top:15em;"><a href="" onclick="javascript:bookmarksite('Anchor', 'http://thenerdshow.com/anchor.html')">
FAVORITE</a></div>

<div style="text-align:center; width:150px;">
<form action="https://www.paypal.com/cgi-bin/webscr" method="post">
<input type="hidden" name="cmd" value="_s-xclick" />
<input type="hidden" name="hosted_button_id" value="9TX9RXWDZKVQY" />
<input type="image" src="https://www.paypal.com/en_US/i/btn/btn_donateCC_LG.gif" border="0" name="submit" alt="PayPal - The safer, easier way to pay online!" />
<img alt="" border="0" src="https://www.paypal.com/en_US/i/scr/pixel.gif" width="1" height="1" />
</form></div><div>

<div style="width:150px;">
Follow me on <a href="http://twitter.com/TheManyOne">Twitter</a>, <a href="http://YouTube.com/TheManyOne">YouTube</a>
<a href="http://themanyone.blogspot.com/">Blogspot</a></div><p>

Announce to:</p>
    <div >
        <a href="http://www.blinklist.com/index.php?Action=Blink/addblink.php">BlinkList</a>
        <br />  <a href="http://del.icio.us/post">del.icio.us</a>
        <br />  <a href="http://digg.com/submit?phase=2">Digg it</a>
        <br />  <a href="http://www.furl.net/storeIt.jsp">Furl</a>
        <br />  <a href="http://ma.gnolia.com/bookmarklet/add">ma.gnolia</a>
        <br />  <a href="http://www.netvouz.com/action/submitBookmark?popup=no">Netvouz</a>
        <br />  <a href="http://www.rawsugar.com/pages/tagger.faces">RawSugar</a>
        <br />  <a href="http://www.shadows.com/features/tcr.htm">Shadows</a>
        <br />  <a href="http://simpy.com/simpy/LinkAdd.do">Simpy</a>
        <br />  <a href="http://www.spurl.net/spurl.php">Spurl</a>
        <br />  <a href="http://myweb2.search.yahoo.com/myresults/bookmarklet">Yahoo MyWeb</a>
        <br />  <a href="http://www.google.com/bookmarks/mark?op=edit">Google</a>
        <br />  <a href="http://www.dzone.com/links/add.html">DZone</a>
        <br />  <a href="http://www.stumbleupon.com/submit">StumbleUpon</a>
        <br />  <div><a href="http://www.ifeedreaders.com/social-creator/" style="font:9px Verdana, Arial, Helvetica, sans-serif; width:100px;">Create Social Bookmark Links</a></div>
    </div>
</div>

</body>
</html>
